-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_allpoints"

-- **************************************************
-- General information about this script
-- **************************************************

DS_allpoints = {}

function DS_allpoints:Name()
	return "All points"
end

function DS_allpoints:Version()
	return "0.1"
end

function DS_allpoints:Description()
	return "Go through all layers"
end

function DS_allpoints:Creator()
	return "dauid.com"
end

function DS_allpoints:UILabel()
	return"All points"
end

-- **************************************************
-- The guts of this script
-- **************************************************
local points = {}


function DS_allpoints:savePoints(moho)
local mesh = moho:Mesh()
	if (mesh ~= nil) then
		for i = 0, mesh:CountPoints() - 1 do
			points[#points+1] = mesh:Point(i)
		end
		mesh:PrepMovePoints()
		moho:NewKeyframe(CHANNEL_POINT)
		moho:AddPointKeyframe(moho.frame)
		
	end
end

function DS_allpoints:goThrough(moho, layer, nr)
	--
	
	moho:SetSelLayer(layer)
	if ((layer:LayerType() == MOHO.LT_GROUP) or (layer:LayerType() == MOHO.LT_SWITCH) or (layer:LayerType() == MOHO.LT_BONE)) then		
		--print("Group "..nr .." - "..layer:Name())
		local layer = moho:LayerAsGroup(layer)
		for i= 0, layer:CountLayers()-1 do
		self:goThrough(moho, layer:Layer(i), i)
		end
	else
		if layer:LayerType() == MOHO.LT_VECTOR then
		self:savePoints(moho)
		end
	end
	
end

function DS_allpoints:Run(moho)    
points = {}
	local originalLayer = moho.layer
	local numlayers = moho.document:CountLayers() --Do top layers
		for i = 0, numlayers - 1 do
			moho:SetSelLayer(moho.document:Layer(i))
			local layer = moho.document:Layer(i)
			self:goThrough(moho, layer, i)
		end
		
		for k, v in pairs(points) do
			local old = v.fAnimPos:GetValue(moho.frame)
			local new = LM.Vector2:new_local()
			new.y = old.y
			new.x = old.x + 0.5
			print("Original: "..v.fPos.x)
			v.fAnimPos:SetValue(moho.frame, new)
			print("Changed"..v.fPos.x)
		end
		moho:SetSelLayer(originalLayer)
end
