-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_CoronaKey"

-- **************************************************
-- General information about this script
-- **************************************************

DS_CoronaKey = {}

function DS_CoronaKey:Name()
	return "Save to Corona"
end

function DS_CoronaKey:Version()
	return "0.5"
end

function DS_CoronaKey:Description()
	return "Save to Corona"
end

function DS_CoronaKey:Creator()
	return "dauid.com"
end

function DS_CoronaKey:UILabel()
	return("Save to Corona")
end

-- **************************************************
-- Recurring values
-- **************************************************
DS_CoronaKey.relativePos = false 
DS_CoronaKey.relativeAngle = false
DS_CoronaKey.relativeScale = false
DS_CoronaKey.relativeOpacity = false

--************************menu
local DS_Dialog = {}

DS_Dialog.UPDATE = MOHO.MSG_BASE

function DS_Dialog:new(moho)

	local d = LM.GUI.SimpleDialog("Settings", DS_Dialog)
	local l = d:GetLayout()
	
	d.moho = moho
	
	l:PushH()
		l:PushV()
			relapBox = LM.GUI.CheckBox("Relative positions")
			l:AddChild(relapBox, LM.GUI.ALIGN_LEFT)
			relapBox:SetValue(DS_CoronaKey.relativePos)
			relaaBox = LM.GUI.CheckBox("Relative angles")
			l:AddChild(relaaBox, LM.GUI.ALIGN_LEFT)
			relaaBox:SetValue(DS_CoronaKey.relativeAngle)
			relasBox = LM.GUI.CheckBox("Relative scale")
			l:AddChild(relasBox, LM.GUI.ALIGN_LEFT)
			relasBox:SetValue(DS_CoronaKey.relativeScale)
			relaoBox = LM.GUI.CheckBox("Relative opacity")
			l:AddChild(relaoBox, LM.GUI.ALIGN_LEFT)
			relaoBox:SetValue(DS_CoronaKey.relativeOpacity)
		l:Pop()
	l:Pop()
	

	return d
end

function DS_Dialog:UpdateWidgets()
	
end


function DS_Dialog:OnOK()
DS_CoronaKey.relativePos=relapBox:Value()
DS_CoronaKey.relativeAngle=relaaBox:Value()
DS_CoronaKey.relativeScale=relasBox:Value()
DS_CoronaKey.relativeOpacity=relaoBox:Value()
end

-- **************************************************
-- The guts of this script
-- **************************************************
function DS_CoronaKey:checkInterp(moho, ch, frame, lastKey)
	--print("Up here")
	if ch:GetKeyInterpMode(frame) == 0 and lastKey == 0 then
		return "linear"
	end
	if ch:GetKeyInterpMode(frame) == 0 and lastKey == 7 then
		return "linear"
	end
	if ch:GetKeyInterpMode(frame) == 0 and lastKey == 8 then
		return "easeOut"
	end
	if ch:GetKeyInterpMode(frame) == 7 and lastKey == 8 then
		return "easeInOut"
	end
	if ch:GetKeyInterpMode(frame) == 2 and lastKey == 2 then
		return "easeInOut"
	end
	
end

function DS_CoronaKey:Run(moho)

local dlog = DS_Dialog:new(moho)
	if (dlog:DoModal() == LM.GUI.MSG_CANCEL) then
		return
	end

local path = LM.GUI.SaveFile("Select Data File")
	if (path == "") then
		return
	end
	path = path..".lua"

	local f = io.open(path, "w")
	if (f == nil) then
		return
	end
	
local width = moho.document:Width()
local height = moho.document:Height()
local aspect = moho.document:AspectRatio()
local newX = (moho.document:Width()/2)
local newY = moho.document:Height()/2
local newZ = moho.document:Height()/2
local fps = moho.document:Fps()
local startframe = moho.document:StartFrame()
local endframe = moho.document:EndFrame()
local anchor= LM.Vector2:new_local()
local translation= LM.Vector3:new_local()
local Originaltranslation= LM.Vector3:new_local()
local layer =moho.layer
local scale= LM.Vector3:new_local()
local Originalscale= LM.Vector3:new_local()
local lastKey, Delay, Duration, Rotation, Opacity, originalRotation, originalOpacity
local Interp = 0

anchor = layer:Origin()
translation = layer.fTranslation:GetValue(startframe)
Originaltranslation = layer.fTranslation:GetValue(startframe)
Rotation = math.deg(layer.fRotationZ:GetValue(startframe)*(-1))
originalRotation = math.deg(layer.fRotationZ:GetValue(startframe)*(-1))
scale = layer.fScale:GetValue(startframe)
Originalscale = layer.fScale:GetValue(startframe)
Opacity = layer.fAlpha:GetValue(startframe)
originalOpacity = layer.fAlpha:GetValue(startframe)

f:write("local function keyframe(object) \n")
	local penis
	if (aspect >0) then
		local newX =(((translation.x+anchor.x) + 1) * newY)+(newX-newY)
		local newY = (((translation.y+anchor.y)*(-1)) + 1) * newY
		translation.x =newX
		translation.y = newY
		Originaltranslation.x = newX
		Originaltranslation.y = newY
	else
		local newX = (((translation.x+anchor.x) + 1) * newX)
		local newY = (((translation.y+anchor.y)*(-1)) + 1) * newX + (newY-newX)
		translation.x = newX
		translation.y = newY
		Originaltranslation.x = newX
		Originaltranslation.y = newY
	end
	
	if self.relativePos then
		f:write("local originalX= object.x".."\n")
		f:write("local originalY= object.y".."\n")
	else
		f:write("object.x="..translation.x.."\n")
		f:write("object.y="..translation.y.."\n")
	end
	if self.relativeAngle then
		f:write("local originalAngle= object.rotation".."\n")
	else
		f:write("object.rotation="..Rotation.."\n")
	end
	if self.relativeScale then
		f:write("local oxScale= object.xScale".."\n")
		f:write("local oyScale= object.yScale".."\n")
	else
		f:write("object.xScale="..scale.x.."\n")
		f:write("object.yScale="..scale.y.."\n")
	end
	if self.relativeOpacity then
		f:write("local oOpacity = object.alpha".."\n")
	else
		f:write("object.Opacity="..Opacity.."\n")
	end
	
	lastKey = startframe
	f:write("--Positions\n")
	for i=startframe, endframe do
		local ch = layer.fTranslation
		if ch:HasKey(i) then
			
			if ch:GetKeyInterpMode(i) == 0 and ch:GetKeyInterpMode(lastKey) == 0 then
				Interp = "linear"
			end
			if ch:GetKeyInterpMode(i) == 0 and ch:GetKeyInterpMode(lastKey) == 7 then
				Interp = "linear"
			end
			if ch:GetKeyInterpMode(i) == 0 and ch:GetKeyInterpMode(lastKey) == 8 then
				Interp = "easeOut"
			end
			if ch:GetKeyInterpMode(i) == 7 and ch:GetKeyInterpMode(lastKey) == 0 then
				Interp = "easeIn"
			end
			if ch:GetKeyInterpMode(i) == 7 and ch:GetKeyInterpMode(lastKey) == 8 then
				Interp = "easeInOut"
			end
			if ch:GetKeyInterpMode(i) == 2 and ch:GetKeyInterpMode(lastKey) == 2 then
				Interp = "easeInOut"
			end
			--print(Interp)

			
			translation = layer.fTranslation:GetValue(i)
			Delay = ((lastKey - startframe)/fps)*1000
			Duration = ((i - lastKey)/fps)*1000
			if (aspect >0) then
				translation.x = (((translation.x+anchor.x) + 1) * newY)+(newX-newY)
				translation.y = (((translation.y+anchor.y)*(-1)) + 1) * newY
			else
				translation.x = (((translation.x+anchor.x) + 1) * newX)
				translation.y = (((translation.y+anchor.y)*(-1)) + 1) * newX + (newY-newX)
			end
			
			if self.relativePos then
				translation = translation - Originaltranslation
			end
			
			if self.relativePos then
				f:write("delay("..Delay..", {func=function(x) move(object, {time="..Duration..",x=originalX + "..translation.x..", y= originalY + "..translation.y..", tween='"..Interp.."'})end}) \n")
			else
				f:write("delay("..Delay..", {func=function(x) move(object, {time="..Duration..",x="..translation.x..", y="..translation.y..", tween='"..Interp.."'})end}) \n")
			end
			lastKey = i
		end
	end
	
	lastKey = startframe
	f:write("--Rotations\n")
	for i=startframe, endframe do
		if layer.fRotationZ:HasKey(i) then
			
			Rotation = math.deg(layer.fRotationZ:GetValue(i)*(-1))
			if self.relativeAngle then
				Rotation = Rotation -originalRotation
			end
			Delay = math.ceil(((lastKey - startframe)/fps)*1000)
			Duration = math.ceil(((i - lastKey)/fps)*1000)
			
			if self.relativeAngle then
				f:write("delay("..Delay..", {func=function(x) move(object, {time="..Duration..",angle= originalAngle + "..Rotation.."})end}) \n")
			else
				f:write("delay("..Delay..", {func=function(x) move(object, {time="..Duration..",angle="..Rotation.."})end}) \n")
			end
			lastKey = i
		end
	end
	
	lastKey = startframe
	f:write("--Scale\n")
	for i=startframe, endframe do
		if layer.fScale:HasKey(i) then
			if self.relativeScale then
				scale = layer.fScale:GetValue(i)-Originalscale
			else
				scale = layer.fScale:GetValue(i)
			end
			Delay = ((lastKey - startframe)/fps)*1000
			Duration = ((i - lastKey)/fps)*1000
			if self.relativeScale then
				f:write("delay("..Delay..", {func=function(x) move(object, {time="..Duration..",xScale= oxScale + "..scale.x..", yScale= oyScale + "..scale.y.."})end}) \n")
			else
				f:write("delay("..Delay..", {func=function(x) move(object, {time="..Duration..",xScale="..scale.x..", yScale="..scale.y.."})end}) \n")
			end
			lastKey = i
		end
	end
	
	lastKey = startframe
	f:write("--Opacity\n")
	for i=startframe, endframe do
		if layer.fAlpha:HasKey(i) then
			if self.relativeOpacity then
				Opacity = layer.fAlpha:GetValue(i)-originalOpacity
			else
				Opacity = layer.fAlpha:GetValue(i)
			end
			Delay = ((lastKey - startframe)/fps)*1000
			Duration = ((i - lastKey)/fps)*1000
			if self.relativeOpacity then
				f:write("delay("..Delay..", {func=function(x) move(object, {time="..Duration..",alpha= oOpacity + "..Opacity.."})end}) \n")
			else
				f:write("delay("..Delay..", {func=function(x) move(object, {time="..Duration..",alpha="..Opacity.."})end}) \n")
			end
			lastKey = i
		end
	end
	
f:write("end \n")
f:close() --Close the file

end